<?php

namespace Gift4U\Admin\Views;

defined( 'ABSPATH' ) || exit;

/** @var \WC_Product $product_object */
global $product_object, $post;

?>
<div class="gift4u-tab-content" data-tab="coupon">

	<?php
	woocommerce_wp_checkbox( [
		'id'    => '_gift4u_cp_email_restrictions',
		'value' => $product_object->get_meta( '_gift4u_cp_email_restrictions' ) ? 'yes' : 'no',
		'label' => esc_html__( 'Email restrictions', 'gift4u-gift-cards-all-in-one-for-woo' ),
	] );

	woocommerce_wp_checkbox( [
		'id'    => '_gift4u_cp_allow_shipping',
		'value' => $product_object->get_meta( '_gift4u_cp_allow_shipping' ) ? 'yes' : 'no',
		'label' => esc_html__( 'Allow shipping', 'gift4u-gift-cards-all-in-one-for-woo' ),
	] );

	woocommerce_wp_text_input( [
		'id'                => '_gift4u_cp_expiry_date',
		'type'              => 'number',
		'label'             => esc_html__( 'Expiry date after day(s)', 'gift4u-gift-cards-all-in-one-for-woo' ),
		'value'             => $product_object->get_meta( '_gift4u_cp_expiry_date' ),
		'custom_attributes' => [ 'min' => 0 ]
	] );

	woocommerce_wp_text_input( [
		'id'                => '_gift4u_cp_minimum_spend',
		'type'              => 'number',
		'label'             => esc_html__( 'Minimum spend', 'gift4u-gift-cards-all-in-one-for-woo' ),
		'value'             => $product_object->get_meta( '_gift4u_cp_minimum_spend' ),
		'custom_attributes' => [ 'min' => 0 ]
	] );

	woocommerce_wp_text_input( [
		'id'                => '_gift4u_cp_maximum_spend',
		'type'              => 'number',
		'label'             => esc_html__( 'Maximum spend', 'gift4u-gift-cards-all-in-one-for-woo' ),
		'value'             => $product_object->get_meta( '_gift4u_cp_maximum_spend' ),
		'custom_attributes' => [ 'min' => 0 ]
	] );

	woocommerce_wp_checkbox( [
		'id'    => '_gift4u_cp_individual',
		'value' => $product_object->get_meta( '_gift4u_cp_individual' ) ? 'yes' : 'no',
		'label' => esc_html__( 'Individual use only', 'gift4u-gift-cards-all-in-one-for-woo' ),
	] );

	woocommerce_wp_checkbox( [
		'id'    => '_gift4u_cp_exclude_sale_items',
		'value' => $product_object->get_meta( '_gift4u_cp_exclude_sale_items' ) ? 'yes' : 'no',
		'label' => esc_html__( 'Exclude sale items', 'gift4u-gift-cards-all-in-one-for-woo' ),
	] );

	?>
    <p class="form-field ">
        <label for="gift4u_cp_products"><?php esc_html_e( 'Products', 'gift4u-gift-cards-all-in-one-for-woo' ); ?></label>
        <select class="wc-product-search" multiple="multiple" style="width: 50%;" id="gift4u_cp_products" name="_gift4u_cp_products[]"
                data-placeholder="<?php esc_attr_e( 'Search for a product&hellip;', 'woocommerce' ); ?>"
                data-action="woocommerce_json_search_products_and_variations" data-exclude="<?php echo intval( $post->ID ); ?>">
			<?php
			$product_ids = $product_object->get_meta( '_gift4u_cp_products' );
			if ( ! empty( $product_ids ) && is_array( $product_ids ) ) {
				foreach ( $product_ids as $product_id ) {
					$product = wc_get_product( $product_id );
					if ( is_object( $product ) ) {
						echo '<option value="' . esc_attr( $product_id ) . '"' . selected( true, true, false ) . '>' . esc_html( wp_strip_all_tags( $product->get_formatted_name() ) ) . '</option>';// phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
					}
				}
			}
			?>
        </select>
    </p>

    <p class="form-field ">
        <label for="gift4u_cp_excl_products"><?php esc_html_e( 'Exclude products', 'gift4u-gift-cards-all-in-one-for-woo' ); ?></label>
        <select class="wc-product-search" multiple="multiple" style="width: 50%;" id="gift4u_cp_excl_products" name="_gift4u_cp_excl_products[]"
                data-placeholder="<?php esc_attr_e( 'Search for a product&hellip;', 'woocommerce' ); ?>"
                data-action="woocommerce_json_search_products_and_variations" data-exclude="<?php echo intval( $post->ID ); ?>">
			<?php
			$product_ids = $product_object->get_meta( '_gift4u_cp_excl_products' );
			if ( ! empty( $product_ids ) && is_array( $product_ids ) ) {
				foreach ( $product_ids as $product_id ) {
					$product = wc_get_product( $product_id );
					if ( is_object( $product ) ) {
						echo '<option value="' . esc_attr( $product_id ) . '"' . selected( true, true, false ) . '>' . esc_html( wp_strip_all_tags( $product->get_formatted_name() ) ) . '</option>';// phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
					}
				}
			}
			?>
        </select>
    </p>

    <p class="form-field">
        <label for="gift4u_cp_categories"><?php esc_html_e( 'Categories', 'woocommerce' ); ?></label>
        <select id="gift4u_cp_categories" name="_gift4u_cp_categories[]" style="width: 50%;" class="wc-enhanced-select" multiple="multiple"
                data-placeholder="<?php esc_attr_e( 'No categories', 'woocommerce' ); ?>">
			<?php
			$category_ids = $product_object->get_meta( '_gift4u_cp_categories' );
			$categories   = get_terms( [ 'taxonomy' => 'product_cat', 'orderby' => 'name', 'hide_empty' => false ] );

			if ( $categories ) {
				foreach ( $categories as $cat ) {
					echo '<option value="' . esc_attr( $cat->term_id ) . '"' . wc_selected( $cat->term_id, $category_ids ) . '>' . esc_html( $cat->name ) . '</option>';// phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
				}
			}
			?>
        </select>
    </p>

    <p class="form-field">
        <label for="gift4u_cp_excl_categories"><?php esc_html_e( 'Exclude categories', 'woocommerce' ); ?></label>
        <select id="gift4u_cp_excl_categories" name="_gift4u_cp_excl_categories[]" style="width: 50%;" class="wc-enhanced-select" multiple="multiple" data-placeholder="<?php esc_attr_e( 'No categories', 'woocommerce' ); ?>">
			<?php
			$category_ids = $product_object->get_meta( 'gift4u_cp_excl_categories' );

			if ( $categories ) {
				foreach ( $categories as $cat ) {
					echo '<option value="' . esc_attr( $cat->term_id ) . '"' . wc_selected( $cat->term_id, $category_ids ) . '>' . esc_html( $cat->name ) . '</option>'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
				}
			}
			?>
        </select>
    </p>
</div>
