jQuery(document).ready(function ($) {
    'use strict';

    const mediaMultiple = wp.media({multiple: true});
    const container = $('#gift4u-images-container');

    const imageTemp = (url, id) => {
        return `<div class="gift4u-image-item vi-ui segment">
                    <span class="gift4u-remove-image">
                        <i class="icon x"> </i>
                    </span>
                    <div class="gift4u-image-wrapper">
                        <img class="gift4u-image" src="${url}"/>
                    </div>
                    <input type="hidden" name="gift4u_gallery_images[]" value="${id}"/>
                </div>`;
    };

    function addImage() {
        mediaMultiple.open().off('select close').on('select', function (e) {
            let selection = mediaMultiple.state().get('selection');
            selection.each(function (attachment) {
                attachment = attachment.toJSON();

                if (attachment.type === 'image') {
                    container.append(imageTemp(attachment.url, attachment.id))
                }
            });
        });
    }

    function removeImage() {
        $(this).closest('.gift4u-image-item').remove();
    }

    function removeAllImage() {
        container.empty();
    }

    $('body').on('click', '.gift4u-add-image', addImage)
        .on('click', '.gift4u-remove-image', removeImage)
        .on('click', '.gift4u-remove-all-image', removeAllImage);

    if (gift4uParams.images) {
        for (let imgId in gift4uParams.images) {
            container.append(imageTemp(gift4uParams.images[imgId], imgId))
        }
    }

});