jQuery(document).ready(function ($) {
    'use strict';
    let $body = $('body'),
        $amountField = $('._gift4u_giftcard_price_field'),
        $fixedDiscount = $('._gift4u_fixed_discount_field'),
        $dynamicDiscount = $('._gift4u_dynamic_discount_field'),
        $minField = $('._gift4u_user_input_min_price_field'),
        $maxField = $('._gift4u_user_input_max_price_field'),
        $discountTable = $('.gift4u-discount-rules tbody');

    if (adminpage && adminpage === 'post-new-php') {
        $('#_gift4u_delivery_date, #_gift4u_sender_name, #_gift4u_recipient_name, #_gift4u_message_field, #_gift4u_shipping_form').attr('checked', true);

        if (typeof gift4uParams.autoChangeProductType !== 'undefined' && gift4uParams.autoChangeProductType) {
            $('#product-type').val('giftcard').trigger('change');
        }
    }

    function displaySelect2(self, select2_args) {
        $(self).selectWoo(select2_args).addClass('enhanced');
    }

    function tab() {
        let tab = $(this).data('tab');
        $('.gift4u-tab-item').removeClass('gift4u-active');
        $('.gift4u-tab-content').removeClass('gift4u-active');
        $(`.gift4u-tab-item[data-tab=${tab}]`).addClass('gift4u-active');
        $(`.gift4u-tab-content[data-tab=${tab}]`).addClass('gift4u-active');
    }

    function pricingTypeChange() {
        let $val = $(this).val();

        $amountField.hide();
        $minField.hide();
        $maxField.hide();
        $fixedDiscount.hide();
        $dynamicDiscount.hide();

        switch ($val) {
            case 'fixed':
                $amountField.show();
                $fixedDiscount.show();
                break;

            case 'input':
                $minField.show();
                $maxField.show();
                $dynamicDiscount.show();
                break;
        }
    }

    function reIndex() {
        $discountTable.find('tr').each(function (i) {
            let $thisRow = $(this);
            $thisRow.find('.gift4u-discount-from-price').attr('name', `_gift4u_discount_rules[${i}][from_price]`);
            $thisRow.find('.gift4u-discount-to-price').attr('name', `_gift4u_discount_rules[${i}][to_price]`);
            $thisRow.find('.gift4u-discount-amount').attr('name', `_gift4u_discount_rules[${i}][discount_value]`);
            $thisRow.find('.gift4u-discount-type').attr('name', `_gift4u_discount_rules[${i}][discount_type]`);
        })
    }

    function getDiscountRowTemplate(i = 0, data = {}) {
        let {from_price = '', to_price = '', discount_value = '', discount_type = 'fixed'} = data;
        let options = '';

        for (let type in gift4uParams.discount_type_options) {
            let selected = discount_type === type ? 'selected' : '';
            options += `<option value="${type}" ${selected}>${gift4uParams.discount_type_options[type]}</option>`;
        }

        let row = `<tr>
                <td>
                    <input type="number" min="0" class="gift4u-discount-from-price" name="_gift4u_discount_rules[${i}][from_price]" value="${from_price}"/>
                </td>
                <td>
                    <input type="number" min="0" class="gift4u-discount-to-price" name="_gift4u_discount_rules[${i}][to_price]" value="${to_price}"/>
                </td>
                <td>
                    <div class="gift4u-discount-rule-amount-wrapper">
                        <input type="number" min="0" class="gift4u-discount-amount" name="_gift4u_discount_rules[${i}][discount_value]" value="${discount_value}"/>
                        <select class="gift4u-discount-type" name="_gift4u_discount_rules[${i}][discount_type]" >
                           ${options}
                        </select>
                    </div>
                </td>
                <td class="gift4u-remove-col">
                    <span class="dashicons dashicons-trash gift4u-remove-row"> </span>
                </td>
            </tr>`;

        return row;
    }

    function addDiscountRow() {
        let newRow = getDiscountRowTemplate();
        $discountTable.append(newRow);
        reIndex();
    }

    function removeDiscountRow() {
        $(this).closest('tr').remove();
        reIndex();
    }

    $body.on('click', '.gift4u-tab-item', tab)
        .on('change', '#_gift4u_price_type', pricingTypeChange)
        .on('click', '.gift4u-add-rule-row', addDiscountRow)
        .on('click', '.gift4u-remove-row', removeDiscountRow);

    $('#_gift4u_price_type').trigger('change');
    $('#_gift4u_price_type option[value="options"],#_gift4u_price_type option[value="slider"],#_gift4u_price_type option[value="product"]').attr('disabled', true);

    if (gift4uParams.rules.length) {
        for (let i in gift4uParams.rules) {
            let row = getDiscountRowTemplate(i, gift4uParams.rules[i]);
            $discountTable.append(row);
        }
    }

    // Ajax product search gallery box
    $(':input.gift4u-select-search').filter(':not(.enhanced)').each(function () {
        let select2_args = {
            allowClear: true,
            placeholder: $(this).data('placeholder'),
            minimumInputLength: $(this).data('minimum_input_length') ? $(this).data('minimum_input_length') : '2',
            escapeMarkup: m => m,
            ajax: {
                url: gift4uParams.ajaxUrl,
                dataType: 'json',
                delay: 250,
                data: (params) => {
                    return {
                        term: params.term,
                        action: $(this).data('action'),
                        security: gift4uParams.nonce,
                        exclude: $(this).data('exclude'),
                        exclude_type: $(this).data('exclude_type'),
                        include: $(this).data('include'),
                        limit: $(this).data('limit'),
                        display_stock: $(this).data('display_stock')
                    };
                },
                processResults: (data) => {
                    let terms = [];
                    if (data) {
                        $.each(data, function (id, text) {
                            terms.push({id: id, text: text});
                        });
                    }
                    return {results: terms};
                },
                cache: true
            }
        };

        displaySelect2(this, select2_args);
    });


    $(':input.gift4u-select2').filter(':not(.enhanced)').each(function () {
        let select2_args = {
            allowClear: true,
            placeholder: $(this).data('placeholder'),
            escapeMarkup: m => m,
        };

        displaySelect2(this, select2_args);
    });

    $('.form-field._manage_stock_field, .inventory_sold_individually, .form-field._sold_individually_field').addClass('show_if_giftcard');
});