jQuery(document).ready(function ($) {
    'use strict';

    function ajaxStep(step = 1) {
        $(`.gift4u-setup-wizard-container [data-step=${step}]`).addClass('active');

        $.ajax({
            url: gift4uParams.ajaxUrl,
            type: 'post',
            dataType: 'json',
            data: {
                action: 'gift4u_setup_wizard',
                nonce: gift4uParams.nonce,
                step: step
            },
            beforeSend() {
            },
            success(res) {
                if (res.success) {

                    if (res.data.editProductUrl) {
                        location.href = res.data.editProductUrl;
                        return;
                    }

                    let nextStep = +res.data.step + 1;
                    ajaxStep(nextStep)
                }
            }
        });
    }

    $('.gift4u-start-setup:not(.gift4u-loading)').on('click', function () {
        $(this).addClass('gift4u-loading');
        ajaxStep();
    });

});