<?php

namespace Gift4U\Inc;

defined( 'ABSPATH' ) || exit;

class Common {
	protected static $instance = null;

	public function __construct() {
		add_action( 'init', [ $this, 'register_custom_post_type' ] );
	}

	public static function instance() {
		return self::$instance == null ? self::$instance = new self() : self::$instance;
	}

	public function register_custom_post_type() {
		$args = [
			'label'               => esc_html__( 'Galleries', 'gift4u-gift-cards-all-in-one-for-woo' ),
			'labels'              => [
				'name'               => esc_html_x( 'Galleries', 'Post Type General Name', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'singular_name'      => esc_html_x( 'Galleries', 'Post Type Singular Name', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'menu_name'          => esc_html__( 'Galleries', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'parent_item_colon'  => esc_html__( 'Parent Gallery', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'all_items'          => esc_html__( 'Galleries', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'add_new_item'       => esc_html__( 'Add New Gallery', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'add_new'            => esc_html__( 'Add New', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'edit_item'          => esc_html__( 'Edit Gallery', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'update_item'        => esc_html__( 'Update Gallery', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'search_items'       => esc_html__( 'Search Gallery', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'not_found'          => esc_html__( 'Not Found', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'not_found_in_trash' => esc_html__( 'Not found in Trash', 'gift4u-gift-cards-all-in-one-for-woo' ),
			],
			'supports'            => [ 'title' ],
			'hierarchical'        => false,
			'public'              => true,
			'show_ui'             => true,
			'show_in_menu'        => 'gift4u',
			'show_in_nav_menus'   => true,
			'show_in_admin_bar'   => false,
			'can_export'          => true,
			'has_archive'         => true,
			'exclude_from_search' => true,
			'publicly_queryable'  => false,
			'capability_type'     => 'product',
			'query_var'           => true,
			'map_meta_cap'        => true,
		];

		register_post_type( 'gift4u_gallery', $args );

		$args = [
			'label'               => esc_html__( 'Card template', 'gift4u-gift-cards-all-in-one-for-woo' ),
			'labels'              => [
				'name'               => esc_html_x( 'Card templates', 'Post Type General Name', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'singular_name'      => esc_html_x( 'Card template', 'Post Type Singular Name', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'menu_name'          => esc_html__( 'Card templates', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'parent_item_colon'  => esc_html__( 'Parent Card template', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'all_items'          => esc_html__( 'Card templates', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'add_new_item'       => esc_html__( 'Add New Card template', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'add_new'            => esc_html__( 'Add New', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'edit_item'          => esc_html__( 'Edit Card template', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'update_item'        => esc_html__( 'Update Card template', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'search_items'       => esc_html__( 'Search Card template', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'not_found'          => esc_html__( 'Not Found', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'not_found_in_trash' => esc_html__( 'Not found in Trash', 'gift4u-gift-cards-all-in-one-for-woo' ),
				'featured_image'     => esc_html__( 'Card template thumnail', 'gift4u-gift-cards-all-in-one-for-woo' ),
			],
			'supports'            => [ 'title', 'thumbnail' ],
			'hierarchical'        => false,
			'public'              => true,
			'show_ui'             => true,
			'show_in_menu'        => 'gift4u',
			'show_in_nav_menus'   => true,
			'show_in_admin_bar'   => false,
			'can_export'          => true,
			'has_archive'         => true,
			'exclude_from_search' => true,
			'publicly_queryable'  => false,
			'capability_type'     => 'product',
			'query_var'           => true,
			'map_meta_cap'        => true,
		];

		register_post_type( 'gift4u_tmpl', $args );
	}
}
