<?php

namespace Gift4U\Inc;

use Gift4U\GiftCard;
use Gift4U\Inc\Classes\Email;
use Gift4U\Inc\Classes\Giftcard_Coupon;

defined( 'ABSPATH' ) || exit;

class Cron {
	protected static $instance = null;

	public function __construct() {
		add_action( 'gift4u_schedule_send_giftcard', [ $this, 'send_giftcard_via_email' ] );
	}

	public static function instance() {
		return self::$instance == null ? self::$instance = new self() : self::$instance;
	}

	/**
	 * @param Giftcard_Coupon $gc_coupon
	 */
	public function send_giftcard_via_email( $gc_coupon ) {
		$gc_mail = new Email( $gc_coupon );
		$gc_mail->send_email( $gc_coupon->get_to_email() );
	}
}
