<?php
/**
 * Created by PhpStorm.
 * User: Villatheme-Thanh
 * Date: 04-05-19
 * Time: 2:55 PM
 */

namespace Gift4U\Inc;


defined( 'ABSPATH' ) || exit;

class Data {
	protected static $params;

	public static function init_params() {
		$option = get_option( 'gift4u_data', [] );
		$params = wp_parse_args( $option, [
			'discount_umpire'           => 'max',
			'order_statuses'            => [ 'completed', 'processing' ],
			'delivery_methods'          => [ 'email', 'ship_card' ],
			'add_card_pdf_to_email'     => '',
			'myaccount_endpoint'        => 'giftcard',
			'show_coupon_list'          => '',
			'email_subject'             => 'You received a gift card from {sender_name}',
			'email_content'             => Utils::email_templates_storage()['default'],
			'coupon_sticker_bg_color'   => '#e90905',
			'coupon_sticker_text_color' => '#ffffff',
			'pdf_file_name'             => '',
		] );

		self::$params = $params;
	}

	public function get_params() {
		if ( ! self::$params ) {
			self::init_params();
		}

		return self::$params;
	}

	public static function get_param( $key ) {
		if ( ! self::$params ) {
			self::init_params();
		}

		return self::$params[ $key ] ?? '';
	}

}
