<?php

namespace Gift4U\Inc;

use Gift4U\Admin\Admin;
use Gift4U\Front\My_Account;
use Gift4U\Front\Order_Process;
use Gift4U\Front\Product_Summary;
use Gift4U\GiftCard;

defined( 'ABSPATH' ) || exit;

class Load_Classes {
	protected static $instance = null;

	public function __construct() {
		require_once plugin_dir_path( __FILE__ ) . 'classes/wc-product-giftcard.php';
		Setup_Wizard::instance();
		Common::instance();
		Enqueue::instance();
		Order_Process::instance();
		Product_Summary::instance();
		My_Account::instance();
		Cron::instance();

		if ( is_admin() ) {
			Admin::instance();
			$this->support();
		} else {
		}
	}

	public static function instance() {
		return self::$instance == null ? self::$instance = new self() : self::$instance;
	}

	protected function support() {
		if ( ! class_exists( 'VillaTheme_Support' ) ) {
			include_once GiftCard::get( 'plugin_dir' ) . 'support/support.php';
		}

		new \VillaTheme_Support( [
			'support'    => 'https://wordpress.org/support/plugin/',
			'docs'       => 'https://docs.villatheme.com/gift4u-gift-cards-all-in-one-for-woo/',
			'review'     => 'https://wordpress.org/support/plugin/gift4u-gift-cards-all-in-one-for-woo/reviews/?rate=5#rate-response',
			'pro_url'    => '',
			'menu_slug'  => 'gift4u',
			'css'        => GiftCard::get( 'css_url' ),
			'image'      => GiftCard::get( 'img_url' ),
			'slug'       => GiftCard::get( 'slug' ),
			'version'    => GiftCard::get( 'version' ),
			'survey_url' => 'https://script.google.com/macros/s/AKfycbyAhsz1DtY3i5UGi-okSAUTgj6YQY_51JWU0N-Dd-iliepjzcKRv2LfBtGNJZt0WUhb/exec'
		] );
	}
}
