<?php
defined( 'ABSPATH' ) || exit;
global $product;

/** @var $add_card_pdf_to_email * */
/** @var $delivery_method_keys * */
/** @var $edit_data * */

?>
<div class="gift4u-section-wrapper">

	<?php do_action( 'gift4u_giftcard_form_start', $product ); ?>

	<?php
	if ( ! empty( $delivery_methods ) ) {
		$first_method = current( array_keys( $delivery_methods ) );

		if ( count( $delivery_methods ) > 1 ) {
			$compare_key = $edit_data['delivery_method'] ?? $first_method;
			?>
            <div class="gift4u-row">
                <label for="">
					<?php esc_html_e( 'Delivery method', 'gift4u-gift-cards-all-in-one-for-woo' ); ?>
                </label>
                <div class="gift4u-delivery-methods">
					<?php
					foreach ( $delivery_methods as $method_slug => $method_name ) {
						$selected = $method_slug === $compare_key ? 'gift4u-button-selected' : '';
						printf( '<span  class="gift4u-button gift4u-select-delivery-method %s" data-value="%s">%s</span>',
							esc_attr( $selected ), esc_attr( $method_slug ), esc_html( $method_name ) );
					}
					?>
                    <input type="hidden" name="gift4u_delivery_method" value="email">
                </div>
            </div>
			<?php
		} else {
			printf( '<label>%s: %s</label>', esc_html__( 'Delivery method', 'gift4u-gift-cards-all-in-one-for-woo' ), esc_html( current( $delivery_methods ) ) );
			printf( '<input type="hidden" name="gift4u_delivery_method" value="%s">', esc_attr( $first_method ) );
		}
	}

	if ( in_array( 'email', $delivery_method_keys ) ) {
		$recipient_emails = '';
		if ( ! empty( $edit_data['recipient_emails'] ) ) {
			$recipient_emails = is_array( $edit_data['recipient_emails'] ) ? implode( ',', $edit_data['recipient_emails'] ) : $edit_data['recipient_emails'];
		}
		?>
        <div class="gift4u-row gift4u-email-method">
            <label for="">
				<?php esc_html_e( 'Recipient email', 'gift4u-gift-cards-all-in-one-for-woo' ); ?>
            </label>
            <input type="text" name="gift4u_recipient_email" class="gift4u-input gift4u-recipient-email" value="<?php echo esc_attr( $recipient_emails ) ?>">
        </div>
		<?php
	}

	if ( $product->get_meta( '_gift4u_delivery_date' ) ) {
		?>
        <div class="gift4u-row">
            <label >
				<?php esc_html_e( 'Delivery date', 'gift4u-gift-cards-all-in-one-for-woo' ); ?>
            </label>
            <input type="date" name="gift4u_delivery_date" class="gift4u-input"
                   value="<?php echo esc_attr( $edit_data['delivery_date'] ?? '' ) ?>"
                   min="<?php echo esc_attr( date( 'Y-m-d', strtotime( 'today' ) ) ) ?>">
        </div>
		<?php
	}

	if ( $product->get_meta( '_gift4u_sender_name' ) ) {
		?>
        <div class="gift4u-row">
            <label for="">
				<?php esc_html_e( 'Sender name', 'gift4u-gift-cards-all-in-one-for-woo' ); ?>
            </label>
            <input type="text" name="gift4u_sender_name" class="gift4u-input gift4u-sender-name" value="<?php echo esc_attr( $edit_data['sender_name'] ?? '' ) ?>">
        </div>
		<?php
	}

	if ( $product->get_meta( '_gift4u_recipient_name' ) ) {
		?>
        <div class="gift4u-row">
            <label for="">
				<?php esc_html_e( 'Recipient name', 'gift4u-gift-cards-all-in-one-for-woo' ); ?>
            </label>
            <input type="text" name="gift4u_recipient_name" class="gift4u-input gift4u-recipient-name" value="<?php echo esc_attr( $edit_data['recipient_name'] ?? '' ) ?>">
        </div>
		<?php
	}

	if ( $product->get_meta( '_gift4u_message_field' ) ) {
		$c_limit = $product->get_meta( '_gift4u_message_character_limit' );
		$c_limit = $c_limit !== '' ? absint( $c_limit ) : $c_limit;
		?>
        <div class="gift4u-row">
            <label>
				<?php
				esc_html_e( 'Message', 'gift4u-gift-cards-all-in-one-for-woo' );
				if ( $c_limit !== '' ) {
					printf( "<span> (%s %s)</span>", absint( $c_limit ), esc_html( _n( 'letter', 'letters', $c_limit, 'gift4u-gift-cards-all-in-one-for-woo' ) ) );
				}
				?>
            </label>
            <textarea name="gift4u_message" rows="3" class="gift4u-input gift4u-message" data-character_limit="<?php echo esc_attr( $c_limit ) ?>"><?php echo wp_kses_post( $edit_data['message'] ?? '' ) ?></textarea>
        </div>
		<?php
	}

	if ( ! empty( $image_ids ) && in_array( 'email', $delivery_method_keys ) ) {
		?>
        <div class="gift4u-row  gift4u-email-method">
            <label for="">
				<?php esc_html_e( 'Email design', 'gift4u-gift-cards-all-in-one-for-woo' ); ?>
                <span class="gift4u-email-design-preview"><?php esc_html_e( 'Preview', 'gift4u-gift-cards-all-in-one-for-woo' ) ?></span>
            </label>
            <div class="gift4u-image-list">
				<?php
				$edit_design = absint( $edit_data['email_design'] ?? 0 );

				foreach ( $image_ids as $index => $image_id ) {
					$image  = wp_get_attachment_image( $image_id, 'full' );
					$active = false;

					if ( $edit_design && $edit_design == $image_id ) {
						$active = true;
					} elseif ( ! $edit_design && $index == 0 ) {
						$active = true;
					}

					printf( '<div class="gift4u-image-item %s" data-image_id="%d"><div class="gift4u-image-padding">%s</div></div>',
						esc_attr( $active ? 'gift4u-selected' : '' ), esc_attr( $image_id ), wp_kses_post( $image ) );
				}

				/** @var  $show_see_more */
				if ( $show_see_more ) {
					printf( "<div class='gift4u-see-more-btn' data-product_id='%d'><span class='gift4u-see-more-text'>%s</span></div>",
						esc_attr( $product->get_id() ), esc_html__( 'See more', 'gift4u-gift-cards-all-in-one-for-woo' ) );
				}

				printf( '<input type="hidden" class="gift4u-email-design" name="gift4u_email_design" value="%s">', esc_attr( current( $image_ids ) ) );
				?>
            </div>
        </div>
		<?php
	}

	$card_template_ids = $product->get_meta( '_gift4u_card_templates' );
	$card_templates    = get_posts( [ 'post_type' => 'gift4u_tmpl', 'include' => $card_template_ids, 'numberposts' => - 1 ] );

	if ( ! empty( $card_templates ) && ( in_array( 'ship_card', $delivery_method_keys ) || ( in_array( 'email', $delivery_method_keys ) && $add_card_pdf_to_email ) ) ) {
		?>

        <div class="gift4u-row gift4u-ship-card-method <?php echo $add_card_pdf_to_email ? 'gift4u-email-method' : '' ?>">
            <label for="">
				<?php esc_html_e( 'Card template', 'gift4u-gift-cards-all-in-one-for-woo' ); ?>
            </label>
            <div class="gift4u-card-template-list">
				<?php
				$card_selected = absint( $edit_data['card_template'] ?? 0 );
				$pass_tmpl_ids = [];

				foreach ( $card_templates as $index => $card_template ) {
					$card_tmpl_id = $card_template->ID;
					$image        = get_the_post_thumbnail( $card_tmpl_id );
					$active       = false;

					if ( $card_selected && $card_selected == $card_tmpl_id ) {
						$active = true;
					} elseif ( ! $card_selected && $index == 0 ) {
						$active = true;
					}

					printf( '<div class="gift4u-card-template-item %s" data-card_template_id="%d">
                                        <div class="gift4u-card-template-padding">%s</div>
                                     </div>',
						esc_attr( $active ? 'gift4u-selected' : '' ), esc_attr( $card_tmpl_id ), wp_kses_post( $image ) );

					$pass_tmpl_ids[] = $card_tmpl_id;
				}

				//				if ( $show_see_more ) {
				//					printf( "<div class='gift4u-see-more-btn' data-product_id='%d'><span class='gift4u-see-more-text'>%s</span></div>",
				//						esc_attr( $product->get_id() ), esc_html__( 'See more', 'gift4u-gift-cards-all-in-one-for-woo' ) );
				//				}


				printf( '<input type="hidden" class="gift4u-card-template" name="gift4u_card_template" value="%s">', esc_attr( $card_selected ? $card_selected : current( $pass_tmpl_ids ) ) );
				?>
            </div>
        </div>
		<?php
	}

	if ( in_array( 'ship_card', $delivery_method_keys ) && $product->get_meta( '_gift4u_shipping_form' ) ) {
		?>
        <div class="gift4u-row gift4u-ship-card-method">
            <label for="">
				<?php esc_html_e( 'Shipping address', 'gift4u-gift-cards-all-in-one-for-woo' ); ?>
            </label>
			<?php
			$checkout = WC_Checkout::instance();
			$fields   = $checkout->get_checkout_fields( 'shipping' );

			unset( $fields['shipping_first_name'] );
			unset( $fields['shipping_last_name'] );
			unset( $fields['shipping_company'] );

			foreach ( $fields as $key => $field ) {
				woocommerce_form_field( $key, $field, $checkout->get_value( $key ) );
			}

			?>
        </div>
		<?php
	}

	if ( ! empty( $edit_data['cart_item_key'] ) ) {
		printf( "<input type='hidden' name='gift4u_update_cart_item' value='%s' />", esc_attr( $edit_data['cart_item_key'] ) );
	}
	?>

</div>